/*
 *  _3 - замена begin() на программирование отдельных регистров
 *       (для модифицированной библиотеки LoRa)
 *  _4 - добавлен вывод дампа регистров     
 *  _5 - посылка пакетов на низком уровне (изменить LoRa.h - writeRegister переместить в public
 *       (на месте часов идет номер принятой посылки, напряжение фиксировано 0.11V, lat = 47 48.3648S
 *  _6 - переделана запись в буфер FIFO (убран первый, но запись идет с указанием адреса)
 *       (все данные идут правильно, RSSI = 046  SNR = 6.2 - непонятно, может так и надо)
 *  _7 - показания напряжения приведены в норму (надо мВ поделить на 6,445)  - ОК (проведены тесты дальности)
 *  _8t20 - увеличена длина пакета до 20 байт - все нормально принимает
 *  _8t40 - до 40 байт, добавлены "псевдоизменения" координат и высоты - нормально принимает
 *  ========================================= далее LGT8F328P SSOP20 ==========================================================
 *  _8lgt - переделано под lgt8f328p ssop20 (изменны выводы)
 *  _8lgtV - изменена процедура readVcc под lgt8f328p (напряжение не мерит)
 *  _9lgt - добавлен парсинг строки $GPGGA
 *  _9lgtTV - в добавлен вывод числа спутников (0,1В = 16) Проверка: показ 3 и времени -3ч, спутн нет 
 *  _9lgtV2 - замер напряжения на А1, спутники убраны
 *  _9lgtV3 - исправлена очистка буфера и процедура парсинга, переделан подсчет периода отправки посылок 4,4В (на самом деле 3,6В)
 *  _9lgtV4 - скоректировано измерение напряжения, в контроль Serial добавлен мигание 200мс  (показывает 0.39В при 3,5В)
 *  _9lgtV5 - скоректировано измерение напряжения (10бит)  - ОК, координаты и напряж  (ходил по полям - 2,3км ОК)
 *             - 0.0002 надо убирать, эти координаты воспринимаются как начальная точка
 *             - по высоте бывают выбросы -17000, -25000 - надо проверить формир.высоты
 *  _10  - изменен алгоритм формирования начальной точки (шел на работу 15.03.21 - ОК, но по высоте выбросы остались)
 *             - похоже, что из-за переполнения буфера Serial идет потеря данных в конце GPGGA (там высота)
 *  _11  - переделана работа приема Serial
 *  pm_11 - переработана под ProMini и L80
 *  pm_12 - в "часах" передается число спутников.
 *  pm_13 - для L80 переделано на предположение, что передаются 4 цифры после запятой в координатах
 *  436pm_14t - Михаил на 436МГц: вариант для делителя напряжения на А1 1:4 (10к : 3к) (t - отключено ожидание спутников)
 *  436pm_14HT18 - Михаил на 436МГц: вариант для GPS модуля HT1818Z3G5L (изменена настройка, $GNGGA, 5 цифр в координатах)
 *  433HT_15 - переделка _14HT18 на Arduino + 433M20SC(pinko) частота 415.2; питание передается не АКБ, а контроллера 
 *    (модуль GPS не принимает комады настройки $PCAS03.... - поэтому нет координат, идет 9992/9993 - слишком много данных)
 *  433HT_16 - переделан прием Serial (в потоке обнаружение GGA и сохранение в буфер только этой строки) 
 *  =============================================================================
 *  ProBmpGPS_E19SC_HT1818_v610 - попытка на базе 433_16 сделать универс.прог
 *         - ошибка tPress переопределена с 5000 на 100 мс - в итоге периодичность 3 сек
 *    v611 - в циклы ожидания добавлена процедура-пустышка (чтение ВМР280, запись 2х байт в EEPROM, включение MOSFET    
 *           (нормально работает, пишет, передает - см тесты)
 *    v612 - развитие процедуры ProcDebug() - Switch-Case: добавлен статус (его передаем в счетчике посылок *1000)
 *           - в отсутствие GPS в поле высоты передается число символов в буфере 100ххх - меньше 30; 200ххх - неверная строка
 *           (работает. исправлена дома)
 *           11.05.2022 - РП32-2 в eeprom нет 10 отсчетов подъема - надо править!
 *    v613 - исправлено: в case 5 - добавлен счетчик адреса        
 *  ==============================================================================
 *    v620 - на базе v613 - исполнительное устройство ССР замена на серво привод (поворот на 90* - крышка закрыта; 0* - открыта)
 *           после включения крышка открывается на 5 сек, потом закрывается.
 *    v620a - изменена индикация ошибки инициализации LoRa (E19) - на led (было 13) - помогло найти непропай SPI
 */


#include <SPI.h>
#include <LoRa.h>
#include <Servo.h>

Servo myservo;  // create servo object to control a servo

// registers
#define _REG_FIFO                 0x00
#define _REG_OP_MODE              0x01
#define _REG_IRQ_FLAGS            0x12
#define _REG_FIFO_ADDR_PTR        0x0d

#define tPress 5000           //период отправки посылок

//#define Kv 0.5                //коэффициент пересчета для напряжения - подобрать!!!

long int tTek;                //отсчет периода отправки посылок
unsigned int counter = 0;     //cчетчик посылок
unsigned int valAlt;
byte datout[40] = {0};        //сам передаваемый массив
int lng = 0;
int lat = 0;
int alt = 0;

int fix;                      //чтоб не ругалось без GPS (заглушка старой версии)
int tmpFix;                   //врем.результат анализа строки GPGGA
byte chGpsLint[128];          // Переменная для хранения GPS-строки, char
//char chGpsLint[128];          // Переменная для хранения GPS-строки, char
word btReaded;                // её длина.
#define gpsBuffer chGpsLint   //чтоб не переписывать
bool bWaitingGps = true;      // Флаг ожидания актуальных данных GPS.
char time1[16];               //временный буфер парсинга NMEA
char time2[5];                //временный буфер парсинга NMEA 2
unsigned int _tmpW = 0;       // временная двухбайтовая переменная для преобразований
unsigned int _tmpW2 = 0;      // временная двухбайтовая переменная для преобразований
unsigned long _tmpL = 0;      // врем 4х байтовая
//String tmpTxt = "$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57";

//E19 433M20SC
#define TxRdy     A3     //готовность устройства (буфер пуст, данные ушли)  DIO0
#define TXEN      3     //включение коммутатора Е19 на передачу (1)
#define E19_RST A2      //сброс
//#define RXEN  //подключен к GND
#define E19_NSS  10     //выбор
//#define MISO,MOSI,SCK  12,11,13  - SPI аппаратный 

float Kv = 0.155;       //пересчет напряжения :  512/3300  (3,3В соотв. 512)
#define led    A0 //11  //светодиод тут
#define LED_PIN  led

boolean BufRdy = false; //готовность GGA в строковом буфере
int GgaCount = 0;       //счетчик поиска подстроки GGA в потоке

//================ дополнение для 610 ======================
#define MinP   40000        //сдвиг давления при хранении в int (пример 101КПа -> 28000)
#define _cs    5 //3 //5  //0   CS         out
#define _mosi  6 //4 //6  //1   MOSI (SDI) out
#define _miso  4 //2 //4  //2   MISO (SDO) input
#define _sck   7 //5 //7        SCK        out

#define _gnd   8 //8   //GND BMP280
#define _vcc   9 //9   //VCC BMP280
//#define led    A0 //11  //светодиод тут
//#define LED_PIN    led
#define _v_plus    A0 //10 //12  //A3  //динамик +
#define _triak     A1 //2 //11 //10  //затвор MOSFET запала (1 - включить)
#define _Read      2    //вход, проверяем при вкл. Если 0, то вывод данных
#define _rf433     1    //передатчик RF433 подключаем к Tx
#define Serv       A1   //подключение сервопривода ССР (вместо транзистора)

//ячейки EEPROM
#include <EEPROM.h>

//распределение памяти EEPROM
#define a_fl_para       0 //byte признак выброса парашюта 1-было 
#define a_fl_start      1 //адрес ячейки с флагом "Обнаружен ли старт"
#define a_fl_fly        1 //byte признак состоявшегося полета (1-был,2-был, но с провалом питания) 
#define a_adr           2 //int адрес включения игнитора
#define a_vcc_mc_st     4 //int питание контроллера на старте
#define a_vcc_acc_st    6 //int питание АКБ
#define a_temp_st       8 //int температура
#define a_press_st     10 //int давление
#define a_vcc_mc_fin   12 //int питание контроллера в конце
#define a_vcc_acc_fin  14 //int питание АКБ
#define a_temp_fin     16 //int температура

#define N0 20            //начало области EEPROM для отсчетов высоты (24c256 - сначала)
#define Alt0  1025.25    //давление на высоте 0
#define MasMax 10//20       //размер массива в ОЗУ (по 2*4 байта) для записи отсчетов до старта                        !!! 20
unsigned int addr = N0;     //пишем отсчеты не с начала EEPROM
unsigned int address = 1024*16;    // текущий адрес начала записи строки 32байтных отсчетов в EEPROM 24cXX
//#define tPress  100      //200      //период опроса датчика                                                             !!! 100
#define maxAddr 1024     //пишем в мегу    //1024*32 //512      //объем EEPROM ATtiny85 =512  //32К для 24С256  с 455                               !!! 1024
#define maxVCC  4000     //пороговое напряжение питания (мВ)
unsigned int maxAlt = 0;           //значение максимальной высоты (давление)
#define maxN 5          //число подряд идущих измерений высот меньших макс для опр.снижения
#define minD 50         //12 //60    //минимальное снижение от максимума для опр.снижения (на более чем 5м: 1м=12отсчетов)  !!!<=============================t2
int N = 0;              //подсчет числа повторов снижения высоты (до maxN)
int ignitON = 0;        //признак "включен ли запал" (0 - не включен)
byte aLow;
byte aHigh;
long int valPress;
long int tBlokCCP;      //тут храним порог времени блокировки обнаружения падения
#define cBlokCCP 2500 //3500   //константа - на это время от старта блокируется срабатывание ССР (нач 2500)
long int tOnCCP;        //тут храним порог времени, когда принудительно включим ССР после старта
#define cOnCCP 15000  //20000    //константа - через это время после старта принудительно сработает ССР (нач 15000)

int Nbuf = 0;            //указатель ОЗУ (до старта отсчеты пишем в ОЗУ)
byte Mas[MasMax*2*4];    //сам массив в ОЗУ для хранения отсчетов до взлета  (10 ячеек по 8 байт)
unsigned int Hmax = 0;   //тут отслеживаем высоту (давление) при определении взлета 
unsigned int H0 = 0;     //тут высота (давление) на старте 
int Kpovt = 0;           //число повторов увеличения высоты при взлете
#define Hd 40 //18  //25 //60       //константа для определения взлета - падение давления (примерно 3м) 12 отсчетов на 1м (5м)  !!!<==============================
#define Kmax 3 //5       //константа число подряд изм.высоты больше макс. для опр.взлета
byte inputBytes[32] = { 0 }; //буфер данных для записи в 24C256
float AX;

//==================== отладка для 611 ==================================
long int debtTek = 0;                //отсчет периода чтения давления
int  debLight = 0;
byte Status = 0;                     //состояние алгоритма 0..9
#define tAltim  100                  //период опроса давления
byte StatH0 = 0;                     //состояние при определении нач.давления 
byte GoodGPS = 2;                    //плохой (0) или хороший (1) GPS; (2) - нет информации
int CtGoodGPS = 0;                   //считаем хорошие посылки GPS
#define MaxGoodGPS 5                 //сколько хороших до приняти решения о 


void ProcDebug()  {
  if (Status == 0) {  //только что включили, надо проверить: был ли полет (ячейка EEPROM)
      //проверка флага "был ли полет" 
      aLow  = EEPROM.read(a_fl_fly);  
      if (aLow > 0) {   //полет уже был - переход в "холостой" режим вывода координат
            Status = 9;  }
      else {
            Status = 1; }//Все ОК - идем по программе далее 
      return;
  }
  // таймер на отсчет tAltim (100 мс)
  if (millis() < debtTek) return;
  debtTek = millis() + tAltim;     //на новый отсчет
  // остальные статусы отрабатываем раз в заданный период

  switch (Status) {
    case 1:
      //ждем стабильного сигнала GPS
      if (GoodGPS == 2) return;  // не было смены состояния
      if (GoodGPS == 1)  {//хорошо, считаем подряд хороших до порога
         GoodGPS = 2;     //сброс в нейтральное состояние
         CtGoodGPS ++;    //считаем
         if (CtGoodGPS > MaxGoodGPS) {  //идет стабильный GPS - можно стартовать
              Status = 2;
              return;
         }      
      } else {  //плохой сигнал GPS
         GoodGPS = 2;     //сброс в нейтральное состояние
         CtGoodGPS = 0;   //счетчик подряд хороших - в ноль
         return;
      }
      break;
    case 2:
      //GPS стабилен - можно лететь. Но сначала определяем начальное давление 
      //определение исходного давления : три отсчета через 500 мс, берем среднее
      StatH0 ++;
      if (StatH0 == 1) {
           Hmax = readPressure();  //первый отсчет
      }
      if (StatH0 == 6) {
           H0 = readPressure();  //через пять циклов опроса - второй отсчет
           if (H0 >= Hmax) {
                 valAlt = H0;
                 H0 = Hmax;
                 Hmax = valAlt;
                 }
           // тут имеем H0 <= Hmax
      }
      if (StatH0 == 11) {
           valAlt = readPressure();  //еще через пять циклов опроса - третий отсчет
           if (valAlt < Hmax) {
                if (valAlt <= H0) Hmax = H0;
                else Hmax = valAlt;
           }
           H0 = Hmax;   //высота (давление) перед стартом
           //пишем начальное значение давления на старте   
           EEPROM.write(a_press_st, lowByte(H0));
           EEPROM.write(a_press_st+1, highByte(H0));
           maxAlt = Hmax;  //тут будем определять минимум давления (макс высота)
           valAlt = readVcc();                //питание устройства VCC(5V)    006
           EEPROM.write(a_vcc_mc_st, lowByte(valAlt));
           EEPROM.write(a_vcc_mc_st+1, highByte(valAlt));
           Status = 3;  //уходим дальше
      }
      break;
    case 3:
      //спутники есть, нач.давление засекли - теперь определяем момент старта
      if (debLight == 0) {   //мигаем, чтоб понять - попадаем ли сюда
        digitalWrite(led, HIGH);  
        debLight = 1;
      }  else  {
        digitalWrite(led, LOW);  
        debLight = 0;
      }
      //пишем отсчеты в ОЗУ до обнаружения старта
      valAlt = readPressure();
      AltToMas(valAlt);  //пишем отсчет в ОЗУ
      if (valAlt < Hmax) {    //до 308 было <=
         //с высотой давление падает, поэтому ищем понижение
         Hmax = valAlt;
         Kpovt ++;         }
      else {
         Kpovt = 0;  //сброс числа повторений
         Hmax = H0;  //сброс начальной высоты (добавлено в 306b)
      } 
      if (Hmax >= (H0 - Hd) || Kpovt < Kmax) {return;} //пока давление не упало на Hd и число повторов падения давления меньше Кмакс - ждем
      //летим...  идем в основной цикл регистрации
      Nbuf = (MasMax-1)*2*4;           //подготовка к перезаписи ОЗУ в EEPROM
      addr = MasMax*2 + N0;            //адрес EEPROM для фиксации высоты

      valAlt = BMP280_readTemperature() +2000; //температура с BMP280    на 20 градусов выше и в 100 раз больше
      EEPROM.write(a_temp_st, lowByte(valAlt));
      EEPROM.write(a_temp_st+1, highByte(valAlt));
  
      EEPROM.write(a_fl_fly, 1);      //ставим признак "полетели"
      //       a_fl_fly = 1  как бы полетели, регистрация пошла, будет сбой - регистрацию не вкл!

      //первый отсчет полета пишем в край ОЗУ 
      Mas[Nbuf+2] = lowByte(valAlt);        //температура 
      Mas[Nbuf+3] = highByte(valAlt);

      valAlt = readVcc();                   //питание устройства VCC(5V)    006
      Mas[Nbuf+6] = lowByte(valAlt);        //вместо Z
      Mas[Nbuf+7] = highByte(valAlt);

      //а вот давление пишем в следующем отсчете - поэтому сделаем отдельный case
      Status = 4;
      break;
    case 4:
      //добавлен только для записи давления в конец ОЗУ перед началом регистрации в EEPROM
      //первый отсчет полета пишем в край ОЗУ 
      valAlt = readPressure();              //Высота  (давление)
      Mas[Nbuf] = lowByte(valAlt);
      Mas[Nbuf+1] = highByte(valAlt);
      // определим время блокировки алгоритма определения падения
      tBlokCCP = millis() + cBlokCCP;
      // определим время принудительного срабатывания ССР
      tOnCCP = millis() + cOnCCP;
      Status = 5;
      break;
    case 5:
      //летим - пишем давление в EEPROM и переписываем из ОЗУ в EEPROM потихоньку достартовые отсчеты
      addr = addr + 2;   //к след  (испр в v613)
      valAlt = readPressure();  //Высота  (давление)
      MasToEE(valAlt);  //запись в EEPROM 
      //анализируем давление и время для определения срабатывания ССР 
//**************************************************************************************
      //определяем момент включения "запала системы спасения"
      if (ignitON == 0) {  //только если запал еще не включали 
           //с 308 добавлено время принудительного включения ССР
           if (millis() > tOnCCP) {  
                  //запишем в EEPROM момент включения "запала" (addr+2)
                  EEPROM.write(a_adr, lowByte(addr+2));
                  EEPROM.write(a_adr+1, highByte(addr+2));
                  //выставим флаги полета
                  EEPROM.write(a_fl_para, 2);      //ставим признак - был выброс парашюта по сраб таймера, а не высотомера
                  Status = 7;                      //признак "сработала ССР по таймеру"
        
                  //включим "запал", либо повернем сервопривод
                  //digitalWrite(_triak, HIGH);
                  myservo.write(0);              // tell servo to go to position 0*   (открываем люк)
                  ignitON = 1; //признак "Запал включен"
                  return;
          }
          if (valAlt < maxAlt) {  //"копим" максимум высоты - идет "взлет" (падение давления)
                  maxAlt = valAlt;
                  N = 0;   }           //сброс счетчика повтора отсчетов со снижением
          else {  //возможно, пошло падение (либо "зависли" на одной высоте :)
                  //с 308 добавлено время блокировки - защита от возможных "подземлю" при резком старте
                  if (millis() > tBlokCCP) {  
                           N ++;  //считаем число повторов "понижения"
                           if (N > maxN) {  //число подряд "понижений" превысило порог - можно сказать - "падаем"
                                  //проверим абсолютное значение "падения" к максимуму
                                  if ((valAlt - maxAlt) > minD) { //тут пора включать "запал"
                                      //запишем в EEPROM момент включения "запала" (addr+2)
                                      //после включения игнитора может "провалиться" питание и контроллер перестанет работать
                                      //после перегорания нити питание восстановится - регистрация должна продолжиться с этого адреса
                                      EEPROM.write(a_adr, lowByte(addr+2));
                                      EEPROM.write(a_adr+1, highByte(addr+2));
                                      //выставим флаги полета
                                      EEPROM.write(a_fl_para, 1);    //ставим признак - выброс парашюта по высотомеру
                                      Status = 6;                    //признак "сработала ССР" - в пакете минуты широты (1-ок,2-таймер)
                                      //включим "запал", либо повернем сервопривод
                                      //digitalWrite(_triak, HIGH);
                                      myservo.write(0);              // tell servo to go to position 0*  (открываем люк)
                                      ignitON = 1; //признак "Запал включен"
                                  }
                            }
                    } 
          }
      }
      break;
    case 6:
      //все сработало по датчику давления, просто смотрим заполнение памяти
      addr = addr + 2;   //к след
      if (addr >= maxAddr)  {
        // запись завершена - фиксируем конечные данные
        valAlt = BMP280_readTemperature() +2000; //температура с BMP280 на 20 градусов выше и в 100 раз больше
        EEPROM.write(a_temp_fin, lowByte(valAlt));
        EEPROM.write(a_temp_fin+1, highByte(valAlt));
        valAlt = readVcc();                //питание устройства VCC(5V)    002
        EEPROM.write(a_vcc_mc_fin, lowByte(valAlt));
        EEPROM.write(a_vcc_mc_fin+1, highByte(valAlt));
        Status = 8;  //регистрация завершена
        return;
      }
      wrPressEE();   //пишем давление в память
      break;
    case 7:
      //как и в 6 - все сработало по таймеру, просто смотрим заполнение памяти
      addr = addr + 2;   //к след
      if (addr >= maxAddr)  {
        // запись завершена - фиксируем конечные данные
        valAlt = BMP280_readTemperature() +2000; //температура с BMP280 на 20 градусов выше и в 100 раз больше
        EEPROM.write(a_temp_fin, lowByte(valAlt));
        EEPROM.write(a_temp_fin+1, highByte(valAlt));
        valAlt = readVcc();                //питание устройства VCC(5V)    002
        EEPROM.write(a_vcc_mc_fin, lowByte(valAlt));
        EEPROM.write(a_vcc_mc_fin+1, highByte(valAlt));
        Status = 8;  //регистрация завершена
        return;
      }
      wrPressEE();   //пишем давление в память
      break;
    case 8:
      //память заполнена, можно включить ССР и просто слать координаты
      return;
      break;
    default: 
      // выполняется, если не выбрана ни одна альтернатива 
      // оставляем только передачу координат (можно было бы включить ССР)
      return;
  }
/*  ----------- отладка в 611 ----------------
  if (debLight == 0) {   //мигаем, чтоб понять - попадаем ли сюда
        digitalWrite(_triak, HIGH);  
        debLight = 1;
  }  else  {
        digitalWrite(_triak, LOW);  
        debLight = 0;
  }
  
  addr = addr + 2;   //в 470 пишем в Мегу только давление
  if (addr >= maxAddr)  {
        //больше в память не пишем, включим MOSFET
        valAlt = readPressure();    //читаем давление для имитации работы
        //включим "запал"
        digitalWrite(_triak, HIGH);
        ignitON = 1; //признак "Запал включен"  
  }
  valAlt = readPressure();    //читаем давление и пишем в память
  EEPROM.write(addr, lowByte(valAlt));
  EEPROM.write(addr+1, highByte(valAlt));
  */
}

void wrPressEE() {
  valAlt = readPressure();    //читаем давление и пишем в память
  EEPROM.write(addr, lowByte(valAlt));
  EEPROM.write(addr+1, highByte(valAlt));
}
//==================== конец отладки ====================================

//+++++++++++++++++++++ доп процедуры 610 +++++++++++++++++++++++++++++++
 /* -----------------------------------------------------------
 процедура сброса признаков полета ракеты
 признак старта, признак выброса парашюта, признак прошедшего полета
 */
 void resetFlags(byte fl_start=0, byte fl_para=0, byte fl_fly=0) {     
 //    EEPROM.write(a_fl_start, fl_start);  //ставим признак - не было старта 
     EEPROM.write(a_fl_para, fl_para);    //ставим признак - не было выброса парашюта 
     EEPROM.write(a_fl_fly, fl_fly);      //ставим признак - не было полета 
 }

/* -----------------------------------------------------------
 процедура "остановки" с заданной индикацией
 0 - двойные вспышки и длинные бипы
 1 - LED не меняется, *-*- пауза
 */
 void stopProc(int func = 0) {  
    if (func == 0) {   
 // останавливаемся с двойными вспышками и бипами
      while (1) {
        digitalWrite(led, HIGH);
        delay(200);               
        digitalWrite(led, LOW); 
        delay(200);               
        digitalWrite(led, HIGH);
        delay(200);               
        digitalWrite(led, LOW); 
        Beep();                   // звуковой сигнал 0,4 сек
        delay(600);               
        }
     }
    if (func == 1) {
      while (1) {
             Beep60();        
             delay(200);  
             Beep();                   // звуковой сигнал сброса флага запрета .-.-
             delay(200);               // короткий - длинный - короткий - длинный 
             Beep60();        
             delay(200);  
             Beep();        
             delay(1000); 
      } 
    } 
    if (func == 2) {
     //включим радиопередатчик с двойными "писками" и двойными длинный звуковой
//      pinMode(_rf433, OUTPUT);     
      while (1) {
//        tone200ms();               
        Beep();                   // звуковой сигнал 0,4 сек  ПискА
//        delay(200);               
//        tone200ms();               
        Beep();                   // звуковой сигнал 0,4 сек  ПискА
        delay(1000);               
        }
      }
      /*
    if (func == 3) {          //обрыв игнитора
          while(1) {
             Beep60();        //даем звуковое оповещение 
             delay(440);      //короткий 
             Beep();          //длинный
             delay(800); 
          }
    } 
    */
    if (func == 4) {          //ошибка инициализации датчика ВМР280
    while (1) {
        digitalWrite(led, HIGH);
        delay(200);               
        digitalWrite(led, LOW); 
        delay(200);               
        digitalWrite(led, HIGH);
        delay(200);               
        digitalWrite(led, LOW); 
        delay(200);               
        digitalWrite(led, HIGH);
        delay(200);               
        digitalWrite(led, LOW); 
        Beep();                   // звуковой сигнал ошибки ВМР -.-
        delay(200);               // длинный - короткий - длинный ПискВ
        Beep60();        
        delay(200);  
        Beep();        
        }
    }
    if (func == 5) {          //ошибка определения давления датчика ВМР280 (за пределами 0+80000..28000+80000)
    while (1) {
        digitalWrite(led, HIGH);  //коротк-длинная вспышка
        delay(200);               
        digitalWrite(led, LOW); 
        delay(200);               
        digitalWrite(led, HIGH);
        delay(800);               
        digitalWrite(led, LOW); 
        Beep();                   // звуковой сигнал ошибки ВМР -..
        delay(200);               // длинный - короткий - короткий ПискС
        Beep60();        
        delay(200);  
        Beep60();        
        }
    }
    if (func == 6) {          //останов с признаком "запись в EEPROM завершена"
      while (1) {
//        tone200ms();               
        digitalWrite(led, HIGH);
        Beep();                   // звуковой сигнал 0,4 сек
        digitalWrite(led, LOW);
        delay(800);               
        }
    }
    if (func == 7) {          //останов с признаком "запись в EEPROM завершена, но был провал питания" 
//       pinMode(_rf433, OUTPUT);     
     while (1) {
//        tone200ms();               
        delay(200);               
        Beep();                   // звуковой сигнал 0,4 сек
//        tone200ms();               
        delay(200);               
        Beep();                   // звуковой сигнал 0,4 сек
//        tone200ms();               
        delay(200);               
        Beep();                   // звуковой сигнал 0,4 сек
        delay(800);               
        }
    }
  //сигнал "по умолчанию"  
     while (1) {
        delay(200);               
        Beep();                   // звуковой сигнал 0,4 сек
        delay(200);               
        Beep();                   // звуковой сигнал 0,4 сек
        delay(200);               
        Beep();                   // звуковой сигнал 0,4 сек
        delay(200);               
        Beep();                   // звуковой сигнал 0,4 сек
        delay(800);               
        }
 }

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


//поиск в потоке GGA и накопление строки в буфере
void ScanSerial() {
   if (!Serial.available()) return;    //буфер пуст - выходим
   char SerCh = Serial.read();
   if (BufRdy) return;                 //данные еще не прочитаны - новые не ищем
   if (GgaCount > 2) {                 //GGA обнаружена - копим данные в буфере
      gpsBuffer[GgaCount] = SerCh;
      GgaCount++;
      if (SerCh != "*") return;        //конца нет - копим данные
      //обнаружен "*" - это конец строки GGA - ставим признак готовности данных
//      GgaCount = 0;                    //счетчик подготовим к новому поиску
      BufRdy = true;                   //готовность GGA в строковом буфере   
   }
   else {                              //GGA еще не нашли в потоке - ждем
      if(GgaCount == 0) {
           if (SerCh == 'G') {GgaCount++;} 
           return;
           }
      if(GgaCount == 1) {
           if (SerCh == 'G') {GgaCount++;} else {GgaCount = 0;}
           return;
           }
      if(GgaCount == 2) {
           if (SerCh == 'A') {GgaCount++;} else {GgaCount = 0;}
           return;
           }   
   }
   
 
}

/*
разбор строки NMEA GPGGA на отдельные переменные
$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57
$GPGGA,073847.00,,,,,,,,,,,,,*57
сразу заполняет разряды буфера 4..19
*/

boolean parsingGPGGA(byte* gpsBuffer, char* time1) {

    int i = 3;
    int j = 0;
/*  в 16 версии уже не проверяем на GGA - получается автоматом...
    if (gpsBuffer[i] == '$') {  //проверяем на GPGGA
        i++;
        j = 0;
        while (gpsBuffer[i] != ',') {
            time1[j++] = gpsBuffer[i++];
        }
//       time1[j] = '\0';
     if (time1[2] != 'G') {return false;}
     if (time1[3] != 'G') {return false;}
     if (time1[4] != 'A') {return false;}
    }
*/
    //собираем время - разобъем на две части: часы-минуты и секунды-сотые, чтоб упаковать в два двухбайтовых числа
    //    payload[14] = UTC_hour               'GPS UTC time - hour As unsigned byte
    //    payload[15] = UTC_minute             'GPS UTC time - minute As unsigned byte
    //    payload[16] = UTC_second             'GPS UTC time - second As unsigned byte

    if ((gpsBuffer[i] == ',') && (gpsBuffer[i+1] != ',')) {
        i++;
        j = 0;
        while ((gpsBuffer[i] != '.')) {  //собрали часы, мин и сек
            time1[j++] = gpsBuffer[i++];
        }
        time2[0] = time1[j-6];   //час
        time2[1] = time1[j-5];
        time2[3] = '\0';
       _tmpW = atof(time2);   //и сразу поместим их в выходной буфер
       datout[14] = lowByte(_tmpW);
        time2[0] = time1[j-4];   //мин
        time2[1] = time1[j-3];
        time2[3] = '\0';
       _tmpW = atof(time2);   //и сразу поместим их в выходной буфер
       datout[15] = lowByte(_tmpW);
        time2[0] = time1[j-2];   //сек
        time2[1] = time1[j-1];
        time2[3] = '\0';
       _tmpW = atof(time2);   //и сразу поместим их в выходной буфер
       datout[16] = lowByte(_tmpW);
      
        i++;
    //десятые и сотые доли секунды пропускаем (они после точки до след.запятой)
         while (gpsBuffer[i] != ',') {
            i++;
    //        time1[j++] = gpsBuffer[i++];
        }
    } else return false;

//----------------V   мы здесь
//$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57
    // запись данных широты
    /*
    payload[0] = Lat_full.Byte3          'GPS Latitude as 32b signed integer, negative means South, the DDMM.MMMM becomes integer number like DDMMMMMM, example: 5107.8136,N --> 51078136 or 5107.8136,S --> -51078136     
    payload[1] = Lat_full.Byte2          'GPS Latitude as 32b signed integer, negative means South, the DDMM.MMMM becomes integer number like DDMMMMMM, example: 5107.8136,N --> 51078136 or 5107.8136,S --> -51078136 
    payload[2] = Lat_full.Byte1          'GPS Latitude as 32b signed integer, negative means South, the DDMM.MMMM becomes integer number like DDMMMMMM, example: 5107.8136,N --> 51078136 or 5107.8136,S --> -51078136 
    payload[3] = Lat_full.Byte0          'GPS Latitude as 32b signed integer, negative means South, the DDMM.MMMM becomes integer number like DDMMMMMM, example: 5107.8136,N --> 51078136 or 5107.8136,S --> -51078136 
    */
    if ((gpsBuffer[i] == ',') && (gpsBuffer[i+1] != ',')) {
        i++;
        j = 0;
         while (gpsBuffer[i] != '.') {
            time1[j++] = gpsBuffer[i++];
        }
        time1[j] = '\0';      //сначала градусы и целые минуты - в двухбайтовое число
        _tmpW = atof(time1);
//        Serial.print("_tmpW ");
//        Serial.println(_tmpW);
           
        i++;  //без всяких точек - в одну строку (пять знаков после запятой)
        j = 0;
        while (gpsBuffer[i] != ',') {
            time1[j++] = gpsBuffer[i++];
        }
        time1[j-1] = '\0';     //пятую цифру выбрасываем (это 2 см)  для Neo-6M и HT1818Z3G5L
//        time1[j] = '\0';     //думаем, что 4 цифры для L80
        _tmpW2 = atof(time1);  
//        Serial.print("_tmpW2 ");
//        Serial.println(_tmpW2);

        _tmpL = (unsigned long) _tmpW * 10000 + _tmpW2;
       datout[0] = lowByte(_tmpL >> 24);
       datout[1] = lowByte(_tmpL >> 16);
       datout[2] = lowByte(_tmpL >> 8);
       datout[3] = lowByte(_tmpL);
//        Serial.print("_tmpL ");
//        Serial.println(_tmpL);

        i++;   //букву N(S) пропускаем - ограничимся северным полушарием
        while (gpsBuffer[i] != ',') {
            i++;
        }
    }  else return false;

//-----------------------------V   мы здесь
//$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57
    // запись данных долготы
    /*
    payload[4] = Lon_full.Byte3          'GPS Longitude as 32b signed integer, negative means West, the DDDMM.MMMM becomes integer number like DDDMMMMMM, example: 00434.7700,E --> 004347700 or 00434.7700,W --> -004347700
    payload[5] = Lon_full.Byte2          'GPS Longitude as 32b signed integer, negative means West, the DDDMM.MMMM becomes integer number like DDDMMMMMM, example: 00434.7700,E --> 004347700 or 00434.7700,W --> -004347700
    payload[6] = Lon_full.Byte1          'GPS Longitude as 32b signed integer, negative means West, the DDDMM.MMMM becomes integer number like DDDMMMMMM, example: 00434.7700,E --> 004347700 or 00434.7700,W --> -004347700
    payload[7] = Lon_full.Byte0          'GPS Longitude as 32b signed integer, negative means West, the DDDMM.MMMM becomes integer number like DDDMMMMMM, example: 00434.7700,E --> 004347700 or 00434.7700,W --> -004347700
    */
    if ((gpsBuffer[i] == ',') && (gpsBuffer[i+1] != ',')) {
        i++;
        j = 0;
        while ((gpsBuffer[i] != '.') && (gpsBuffer[i] != ',')) {
            time1[j++] = gpsBuffer[i++];
        }
        time1[j] = '\0';      //сначала градусы и целые минуты - в двухбайтовое число
        _tmpW = atof(time1);   

        i++;   //без всяких точек - в одну строку (пять знаков после запятой)
        j = 0;
        while (gpsBuffer[i] != ',') {
            time1[j++] = gpsBuffer[i++];
        }
        time1[j-1] = '\0';     //пятую цифру выбрасываем (это 2 см)  для Neo-6M и HT1818Z3G5L
//        time1[j] = '\0';     //думаем, что 4 цифры для L80
        _tmpW2 = atof(time1); 
          
        _tmpL = (unsigned long) _tmpW * 10000 + _tmpW2;
//        Serial.print("_tmpL ");
//        Serial.println(_tmpL);
       datout[4] = lowByte(_tmpL >> 24);
       datout[5] = lowByte(_tmpL >> 16);
       datout[6] = lowByte(_tmpL >> 8);
       datout[7] = lowByte(_tmpL);

        i++;   //букву E(W) пропускаем - ограничимся восточной долготой
        while (gpsBuffer[i] != ',') {
            i++;
        }
    }   else return false;
//-------------------------------------------V   мы здесь
//$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57
    // состояние GPS 
    if ((gpsBuffer[i] == ',') && (gpsBuffer[i+1] != ',')) {
        i++;
        while (gpsBuffer[i] != ',') {
            i++;
        }
    } else i++;
//---------------------------------------------V   мы здесь
//$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57
    //и число спутников     
    if ((gpsBuffer[i] == ',') && (gpsBuffer[i+1] != ',')) {
        i++;
        j = 0;
        while (gpsBuffer[i] != ',') {
        time1[j++] = gpsBuffer[i++];
        }
        time1[j] = '\0';
        _tmpW = atof(time1);   
       datout[14] = lowByte(_tmpW);   //в ячейку часов
//        _tmpW = _tmpW << 4;    //кладем в ячейки для напряжения питания
                               //считаем 0,1В = 16, т.е 5 спутников отобр 0,5; 11 -> 1,1
//       datout[10] = highByte(_tmpW);
//       datout[11] = lowByte(_tmpW);
    } else i++; 

//------------------------------------------------V   мы здесь
//$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57
    // пропуск данных о точности в горизонтали
    if ((gpsBuffer[i] == ',') && (gpsBuffer[i+1] != ',')) {
        i++;
        while (gpsBuffer[i] != ',') {
            i++;
        }
    } else i++;
    
//-----------------------------------------------------V   мы здесь
//$GPGGA,073847.00,5610.83240,N,04045.18088,E,1,04,2.71,115.2,M,10.1,M,,*57
    // запись данных высоты
    // payload[8] = Alt.Byte1               'GPS altitude As 16b signed integer
    // payload[9] = Alt.Byte0               'GPS altitude As 16b signed integer
    if ((gpsBuffer[i] == ',') && (gpsBuffer[i+1] != ',')) {
        i++;
        j = 0;
        while ((gpsBuffer[i] != '.') && (gpsBuffer[i] != ',')) {
//        while (gpsBuffer[i] != '.') {
            time1[j++] = gpsBuffer[i++];
        }
         time1[j] = '\0';
        _tmpW = atof(time1);   //ограничиваемся только целым значением высоты
        datout[8] = highByte(_tmpW);
        datout[9] = lowByte(_tmpW);
//        Serial.print("_tmpW ");
//        Serial.println(_tmpW);

  /*      
       i++;   //без всяких точек - в одну строку (один знак после запятой)
        while (gpsBuffer[i] != ',') {
            time1[j++] = gpsBuffer[i++];
        }
        time1[j] = '\0';
        _tmpW = atof(time1);   //и сразу поместим ее в выходной буфер
        */
    } else {
        _tmpW = 9999;  //как бы ошибка высоты
        datout[8] = highByte(_tmpW);
        datout[9] = lowByte(_tmpW);      
    }
    return true;

}

void SerialFlush() {
  while (Serial.available()) {
    Serial.read();
  }
}



void setup() {

      //управление E19 433M20SC
      pinMode(TxRdy, INPUT);         //готовность устройства (буфер пуст, данные ушли)  DIO0
      pinMode(TXEN, OUTPUT);         //включение коммутатора Е19 на передачу (1)
      digitalWrite(TXEN, LOW);       //коммутатор передачи выключим

  pinMode(LED_PIN, OUTPUT);          //в исх варианте это светодиод
//  analogReference(INTERNAL);    //для ProMini вкл внутр ИОН = 1,1В (делитель 1:4)  - это если АЦП

//  analogReference(INTERNAL2V048);
// по входу А1 измеряем напряжение АКБ 1:2

  myservo.attach(Serv);             // attaches the servo on pin to the servo object (на 0*)
  
  Serial.begin(9600);
  while (!Serial);
  
//+++++++++ инициализация памяти и проверка на необходимость вывода данных EEPROM +++++++++++++++
      pinMode(_gnd, OUTPUT);   //общ BMP280  
      digitalWrite(_gnd, LOW); //общий провод ВМР280 на "землю"
      pinMode(_vcc, OUTPUT);   //питание BMP280  
      digitalWrite(_vcc, LOW); //питание ВМР280 на "землю" (выключим ВМР)
//      pinMode(_triak, OUTPUT);     
//      digitalWrite(_triak, LOW); //транзистор выключим
      pinMode(_v_plus, OUTPUT);     
      digitalWrite(_v_plus, LOW);     //"+" динамика на "землю"
      pinMode(_Read, INPUT);             //проверка - не надо ли данные считать?
      digitalWrite(_Read, HIGH);         //вкл pullup
      if (digitalRead(_Read) == LOW) {
        //питаемся от 5В - включать BMP280 нельзя
//================================================================
        DataPrint();
//================================================================

        resetFlags(0,0,0);            //сбросить все признаки
        stopProc(0);
      }

//+++++++++ конец иниц памяти и вывода ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      digitalWrite(LED_PIN, HIGH);       //контр вспышка
      delay(200);
      digitalWrite(LED_PIN, LOW);        //контр вспышка
      
//отводим рычаг сервопривода в крайнее положение
    myservo.write(0);                  // tell servo to go to position 0
      Beep60();                        // для контроля пискнем два раза
      delay(200);  
      Beep60();                        
    delay(1000);                       // waits 1000ms for the servo to reach the position
//даем 5 сек на установку крышки
    for (int i9=0; i9<5; i9++) {
      Beep60();                        
    delay(1000);                       // waits 1000ms 
    }
//заводим рычаг сервопривода в запирающее положение
    myservo.write(90);                 // tell servo to go to position 90
      Beep60();                        // для контроля пискнем три раза
      delay(200);  
      Beep60();                        
      delay(200);  
      Beep60();                        
    delay(1000);                       // waits 1000ms for the servo to reach the position

  
  //настройка L80

//"RsOut "$PMTK102*31", 13, 10    // Warm start  — это обязательно?"
//  Serial.println("$PMTK102*31");
  delay(2000);
//"RsOut "$PMTK285,3,200*3C", 13, 10   //PPS Pulse Width 200msec  — это наверно можно убрать?"
//Можно. Но может быть Михаил купил L80-R вместо L80 - тогда строчка нужна.
//  Serial.println("$PMTK285,3,200*3C");
//  delay(500);
//"RsOut "$PMTK286,1*23", 13, 10  //AIC (Active  Interference  Cancellation) enabled   — это что? обязательно?"
//Не обязательно, но желательно, так как это улучшает подавление помех
//  Serial.println("$PMTK286,1*23");
//  delay(500);
//"RsOut "$PMTK301,1*2D", 13, 10  //Differential GPS enabled when available  — и это?"
//Ето и не применимо в твоем случае. Ето об использовании наземных GPS станций , где они доступны. Но я думаю, что все наземные GPS станции были удалены в России пару лет назад.
//"RsOut "$PMTK314,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0*29", 13, 10 //Set NMEA output only to GGA message to once every fix, I don't need the rest  — по сути — только это мне нужно."
//  Serial.println("$PMTK314,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0*29");

//  Serial.println("$PCAS03,1,0,0,0,0,0,0,0,0,0,,,0,0*03");  //это для HT1818Z3G5L - оставить только GNGGA
//  delay(500);

//"RsOut "$PMTK886,0*28", 13, 10 //Set navigation mode to normal     --- а до этого было «ненормально»?"
//Это применимо только для L80-R, где можно установить нормальный, динамический или высотного шара. В основном тебе это не нужно. 🙂 
//  Serial.println("$PMTK886,0*28");
//  delay(500);
    
  // override the default CS, reset, and IRQ pins (optional)
//  LoRa.setPins(9, 3, 2); // set CS, reset, IRQ pin
//  LoRa.setPins(10, 3, 2); // set CS, reset, IRQ pin  для ProMini
      LoRa.setPins(E19_NSS, E19_RST, 2); // set CS, reset, IRQ pin(не используется)
      digitalWrite(led,HIGH);

  //запуск с частотой сигнала,полосой и длиной посылки 
  if (!LoRa.beginE19t(415.2E6,62E3,17)) {
//    Serial.println("Starting LoRa failed!");
    while (1) {  //ошибка - частые мигания
//      pinMode(13, OUTPUT);
      digitalWrite(led,HIGH);
      delay(200);
      digitalWrite(led,LOW);
      delay(200);
    }
  }
      digitalWrite(led,LOW);
//  LoRa.dumpRegisters(Serial);

//++++++++++++++++++++ инициализация датчика давления и начальные установки высотомера ++++++++++++++++++
      addr = N0;      //пишем отсчеты не с начала EEPROM
//  itmp = 0;
//  maxAlt = 0;     //значение максимальной высоты
//  N = 0;    //подсчет числа повторов снижения высоты (до maxN)
//  ignitON = 0;    //признак "включен ли запал" (0 - не включен)
      Nbuf = 0;       //указатель ОЗУ (до старта отсчеты пишем в ОЗУ)
      Hmax = 0;       //тут отслеживаем высоту при определении взлета 
      H0 = 0;         //тут высота на старте 
//  Kpovt = 0;      //число повторов увеличения высоты при взлете
  

      Beep();        //один длинный бип после включения
      delay(1000);               
      
      for (int i = 0; i < 5; i ++) {  //и 5 писков в радиоканал
        Beep60();
        delay(400);               
        }
        
    // разрешается фиксировать параметры датчика в EEPROM
      pinMode(_vcc, OUTPUT);     
      digitalWrite(_vcc, HIGH); //питание ВМР280 на VCC
      //пауза 2 сек
      for (int i = 0; i < 10; i ++) {
        digitalWrite(led, HIGH);
        delay(100);               
        digitalWrite(led, LOW); 
        delay(100);               
        }
//        Beep();                   // звуковой сигнал 0,4 сек
 
  if (!BMP280_begin()) {  //если ошибка BMP280 - тройные вспышки
             stopProc(4);              // останов с признаком "ошибка ВМР280"            
    }

//++++++++++++++++++++ конец иниц датчика давления ++++++++++++++++++++++++++++++++++++++++++++++++++++++      
      
      
      
      digitalWrite(LED_PIN, HIGH);       //контр вспышка
      delay(200);
      digitalWrite(LED_PIN, LOW);        //контр вспышка
      newDelay(500);
      digitalWrite(LED_PIN, HIGH);       //контр вспышка
      newDelay(200);
      digitalWrite(LED_PIN, LOW);        //контр вспышка
      
// ждем спутники
//=========== в рабочей версии комментарии с трех строк ниже - лучше снять ==============
//  while (getFix() != 1) {
//      delay(1000);
//  }

      SerialFlush();    //очистим буфер Serial
      GgaCount = 0;
      BufRdy = false;

}

void loop() {
  tTek = millis();

//  Serial.print("NN: ");
//  delay(10);
//  Serial.println(counter);
  newDelay(100);

      for (int ij=0; ij<40; ij++) { 
           datout[ij] = 0;
        }

      while (!BufRdy) {
           ScanSerial();
           ProcDebug(); 
           }
      if (GgaCount > 30) {                  // Данные могут быть актуальны, длина строки от GPS-модуля.
           // тут надо подготовить все данные от GPS
           if (parsingGPGGA(chGpsLint, time1)) {  //заполняем массив
                 GoodGPS = 1;  //очень хорошо - все есть
                }  else  {
                  //строка длинная, но в ней ошибки     
//                  _tmpW = addr; //9992;  //как бы ошибка высоты
                  _tmpW = 20000 + GgaCount;  //как бы ошибка высоты
                  datout[8] = highByte(_tmpW);
                  datout[9] = lowByte(_tmpW);  
                  GoodGPS = 0;    //плохой GPS
                  } 
           }
      else {
             //что-то есть, но мало <48
        _tmpW = 10000 + GgaCount;  //как бы ошибка высоты
        datout[8] = highByte(_tmpW);
        datout[9] = lowByte(_tmpW);      
                  GoodGPS = 0;    //плохой GPS
           }
      GgaCount = 0;
      BufRdy = false;
  
      //посылка из 17 байт
      unsigned int counterT = counter + Status * 1000;     //cчетчик посылок вместе со статусом
      datout[12] = highByte(counterT);
      datout[13] = lowByte(counterT);
  
      valAlt = readVcc();                //питание устройства VCC(5V)    006
      float vA1d = (float) valAlt * Kv * 1.0;                  //надо пересчитать
      valAlt = (unsigned int) vA1d * 1.0; 
//  valAlt = analogRead(A1);   //напряжение АКБ через делитель почти 1:2
//  float vA1d = (float) valAlt * Kv;   //считаем с плавающей точкой
//  valAlt = (int) vA1d * 1.0;                            //возвращаем к целому
      datout[11] = lowByte(valAlt);
      datout[10] = highByte(valAlt);
  
  // send packet
        digitalWrite(LED_PIN, HIGH);
        
        // send packet
        digitalWrite(TXEN, HIGH);   //вкл.коммутатор передатчика Е19         
//        counter ++;   //счетчик посылок
        delay(2);                                   //на всякий случай  
        LoRa.writeRegister(_REG_FIFO_ADDR_PTR, 0);        //сброс указателя
//        SetDatOut();      //подготовка массива отправляемых данных
        for (int i = 0; i < 17; i ++) {
              LoRa.writeRegister(_REG_FIFO, datout[i]);     //данные
              }
        LoRa.writeRegister(_REG_OP_MODE, 0x8b);       //Set Tx mode
        delay(5);
        //проверяем готовность передатчика (окончание отсылки пакета)
        while(digitalRead(TxRdy) == LOW) {
          ProcDebug();
          }  //ждем окончания передачи DIO0
        LoRa.writeRegister(_REG_IRQ_FLAGS, 0xff);     //Need to clear all interrupts
        delay(5);
        digitalWrite(TXEN, LOW);   //выкл.коммутатор передатчика Е19         

        digitalWrite(LED_PIN, LOW);

  
  newDelay(1000);
//  LoRa.dumpRegisters(Serial);

  counter++;

  while ((tTek + tPress) > millis()) {
     ScanSerial(); 
     ProcDebug(); 
    } 
  
}

//новая пауза (задержка) с анализом буфера Serial
void newDelay(long int time_tmp) {
  long int time_tmp0 = millis();
  while ((time_tmp0 + time_tmp) > millis()) {
     ScanSerial();
     ProcDebug();
  }
}


//++++++++++++++++++++ доп процедуры для 610 +++++++++++++++++++++++++
 

//вывод данных из EEPROM по UART  
void DataPrint() {
        Beep();        //два бипа перед выводом
        delay(400);  
        Beep60();     
        
        Serial.println("v620");
        Serial.println(MinP);
        Serial.println("Adr;Low;High;Word;");
        for (addr = 0; addr < maxAddr; addr = addr + 2) {
            if (addr == N0) {
                   Serial.println("-------------;");    
                 }
           aLow  = EEPROM.read(addr);
           aHigh = EEPROM.read(addr+1);
           Serial.print(addr);
           Serial.print(";  ");
                   Serial.print(aLow);    //флаг парашюта для 0
                   Serial.print(";");
                   Serial.print(aHigh);  //флаг полета для 1
           Serial.print(";  ");
           AX = (float) (aLow + aHigh*256.0) * 1.0;
           Serial.print(AX,0);      
//распределение памяти EEPROM
            if (addr == a_fl_para) {
                  //0 byte признак выброса парашюта 1-было 
                  //1 byte признак состоявшегося полета (1-был,2-был, но с провалом питания) 
                   Serial.print("; para; fly");    
                 }
            if (addr == a_adr) {
                  ////int адрес включения игнитора
                  Serial.print("; adr ignit");    
                 }
            if (addr == a_vcc_mc_st) {
                  //int питание контроллера на старте
                  Serial.print("; vcc_mc_st");    
                 }
            if (addr == a_temp_st) {
                  //int температура на старте
                  Serial.print("; temp_st");    
                 }
            if (addr == a_press_st) {
                  //int давление на старте
                  Serial.print("; press_st");    
                 }
            if (addr == a_vcc_mc_fin) {
                  //int питание контроллера в конце
                  Serial.print("; vcc_mc_fin");    
                 }
            if (addr == a_temp_fin) {
                  //int температура в конце
                  Serial.print("; temp_fin");    
                 }
           Serial.println(";");
        }
//        Serial.println("The End Read EEPROM from ATMega328");
        
         Serial.println();   //"24C256 next:");
         Serial.println("'v620");
//          Serial.println("'N;T;P;*C;X-;Y-;Z-;V;");
          //нужна температура, берем с точки старта
          addr = a_temp_st;
          aLow  = EEPROM.read(addr);
          aHigh = EEPROM.read(addr+1);
          float tempD = (float) (aLow+aHigh*256.0 - 2000.0)/100.0;
        float timeD = 0;
        int numD = 0;
        for (addr = N0; addr < maxAddr; addr = addr + 2) {
           aLow  = EEPROM.read(addr);
           aHigh = EEPROM.read(addr+1);
           Serial.print(numD);    //порядковый номер записи (с 0)
           Serial.print(";");
           Serial.print(timeD);   //время в сек
           Serial.print(";");
           AX = (float) (MinP + aLow + aHigh*256.0) * 1.0;
           Serial.print(AX,0);  //высота/давление
           Serial.print(";");
          //нужна температура, берем с яч.[2]&[3]
//           tempD = (float) (inputBytes[2]+inputBytes[3]*256 - 2000)/100.0;
           Serial.print(tempD,2);   //температура в *С
           Serial.print(";");
           Serial.println("0;1;0;1;");  //ускорение не фиксируем
           numD ++;
           timeD += 0.1;
        }
        Serial.println("'===END OF RECORD===");
  
}
